program UDPExample;

	uses
		Events, EPPC, AppleEvents, 
		MyInitialization, MyStartup, MyTransport, MyConnections, MyGrowZones;

	var
		quitNow: Boolean;

	type
		ListenerObject = object(UDPObject)
			procedure PacketAvailable (remoteIP: longInt; remoteport: integer; datap: ptr; datalen: integer);
			override;
		end;
		
	var
		listener: ListenerObject;
			
	procedure ListenerObject.PacketAvailable (remoteIP: longInt; remoteport: integer; datap: ptr; datalen: integer);
	begin
		writeln( remoteIP, ':', remoteport, ' ', datalen );
		writeln( SendPacket( remoteIP, remoteport, datap, datalen, true ) );
	end;
	
	procedure WNE;
		var
			junk: OSErr;
			dummy:Boolean;
			er:EventRecord;
	begin
		dummy:=WaitNextEvent(everyEvent,er,0,nil);
		if er.what = keyDown then begin
			quitNow := true;
		end;
		if er.what = kHighLevelEvent then begin
			junk := AEProcessAppleEvent(er);
		end;
		IdleStartup;
	end;

	var
		msg: integer;
begin
	Initialization;
	quitNow := false;
	InitStartup;
	StartupConnections;
	ConfigureTransport( true );
	ConfigureGrowZones( 20000 );
	if Startup( msg) = noErr then begin
		new( listener );
		if listener.CreatePort( 0, 999 ) = noErr then begin
			writeln( 'Starting' );
			while not quitNow do begin
				WNE;
			end;
			listener.Destroy;
		end;
		FinishStartup;
	end;
end.
